#!/bin/sh
# Copyright (c) 2009 Scorpio IT, Deidesheim, Germany
#
# Author: Christian Wittmer
# please send feedback to rpm (at) scorpio-it (dot) net
#
###################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
#    For information : rpm (at) scorpio-it (dot) net
####################################################################
#
# /etc/init.d/centcore
#   and its symbolic link
# /(usr/)sbin/rccentcore
#
### BEGIN INIT INFO
# Provides:          centcore
# Required-Start:    nagios
# Should-Start:
# Required-Stop:     nagios
# Should-Stop:
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: Start HA Engine
# Description:       Start the centcore High-Availability Engine
### END INIT INFO
#
# Note on runlevels:
# 0 - halt/poweroff                     6 - reboot
# 1 - single user                       2 - multiuser without network exported
# 3 - multiuser w/ network (text mode)  5 - multiuser w/ network and X11 (xdm)
#

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
CC_BIN=/srv/centreon/bin/centcore
[ -x ${CC_BIN} ] || { echo "${CC_BIN} not installed";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

# check for vital config
CC_CONF=/etc/centreon/conf.pm
[ -r ${CC_CONF} ] || { echo "${CC_CONF} not installed";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

PID_FILE=/var/run/centreon/centcore.pid
LOG_FILE=/var/log/centreon/centcore.log
LOCK_FILE=/var/lock/subsys/centcore
NICE=5
CC_Service="HA Engine (centcore)"

[ ! -d /var/run/centreon ] && install -d -m0750 -o nagios -g nagios /var/run/centreon;

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0       - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

# our version of start_proc
#IN: $PID_FILE $LOCK_FILE
start_proc(){
  #set -x
  if [ ! -f $1 ]; then
	# start centcore
	su - nagios -c "nice -n ${NICE} ${CC_BIN} >> ${LOG_FILE} 2>&1 &"
	touch $2
	RET=0
  else
	RET=5
  fi
  return $RET
}

# our version of kill_proc
#IN: $PID_FILE $LOCK_FILE
kill_proc(){
  #set -x
  if [ -f $1 ]; then
    PID=$(head -n 1 $1)
    kill -s INT $PID 2>/dev/null
    RET=$?
    for i in `seq 20` ; do
	if check_proc "${1}" "${2}" > /dev/null; then
	    sleep 1
	else
	    break
	fi
    done
    if check_proc "${1}" "${2}" > /dev/null; then
	RET=1
    else
	RET=0
    fi
  else
    RET=6
  fi
  return $RET
}

# our version of check_proc
#IN: $PID_FILE $LOCK_FILE
check_proc(){
  #set -x
  # check for process
  #ps ax | grep -v grep | grep $3 > /dev/null
  if [ -f $1 ]; then
    ps -p $(cat $1) > /dev/null
    RET=$?
  else
    RET=1
  fi
  if [ $RET = 1 ]; then
    if [ -f $1 ]; then
	rm $1
	ERR=1
    elif [ -f $2 ]; then
	rm $2
	ERR=2
    else
	ERR=3
    fi
  else
    ERR=$RET
  fi
  STATUS=$ERR
  return $STATUS
}

case "$1" in
    start)
	echo -n "Starting ${CC_Service} "
	## Start daemon with start_proc
	start_proc "${PID_FILE}" "${LOCK_FILE}"

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down ${CC_Service} "
	kill_proc "${PID_FILE}" "${LOCK_FILE}"

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset        # Not running is not a failure.
	fi

	# Remember status and be quiet
	rc_status
        ;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    reload|force-reload)
        ## Signal the daemon to reload its config. Most daemons
        ## do this on signal 1 (SIGHUP).
        ## If it does not support it, restart the service if it
        ## is running.

        # centcore does not support SIGHUP, so restart
        #echo -n "Reloading service ${CC_Service} "
        ## if it supports it:
        #/sbin/killproc -HUP ${CC_BIN}

        # Remember status and be verbose
        #rc_status -v

        ## Otherwise:
        $0 try-restart

        # Remember status and be quiet
        rc_status
        ;;
    status)
	echo -n "Checking for service ${CC_Service} "
	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)

	# NOTE: check_proc returns LSB compliant status values.
	check_proc "${PID_FILE}" "${LOCK_FILE}"

	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	# Remember status and be verbose
	rc_status -v
	;;
    *)
	echo "Usage: $0 {start|stop|try-restart|restart|reload|force-reload|status}"
	exit 1
	;;
esac
rc_exit
